/**
 * Copyright (c) 2006 Macacos.org. All Rights Reserved
 *
 * This library is free software; you can redistribute it and/or modify it under the terms of the 
 * GNU Lesser General Public License as published by the Free Software Foundation; either version 
 * 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See 
 * the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this library;
 * if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, 
 * MA  02110-1301  USA
 * 
 * You can find the license also here: http://www.gnu.org/copyleft/lesser.html
 * 
 * 
 * Created on Sep 18, 2006 by Thiago Tonelli Bartolomei
 * -------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m   
 */
package healthwatcher.aspects.exceptionHandling;

import java.io.PrintWriter;
import java.io.IOException;
import java.rmi.RemoteException;

import healthwatcher.view.servlets.*;

import javax.servlet.http.*;

import lib.exceptions.CommunicationException;

/**
 * TODO - describe this file
 * 
 * @author Thiago Tonelli Bartolomei <thiago.bartolomei@gmail.com>
 */
public deployed cclass HWDistributionExceptionHandler {

	void around(HttpServletResponse response) : 
		execution(* HWServlet+.do*(HttpServletRequest, HttpServletResponse)) &&
		args(.., response) {
		try {
			PrintWriter out = response.getWriter();
			try {
				
				proceed(response);
				
	        } catch (CommunicationException e) {
	        	out.println(lib.util.HTMLCode.errorPage("Comunication error, please try again later."));
			} finally {
				// Close output after commands
				// Note that this is a distribution concern, because the retries in the distribution forces
				// the close just after all retries are done
				out.close();
			}
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
}
